package net.mysoftworks.modulecompiler.model.meta;


import net.mysoftworks.modulecompiler.model.enumeration.FilePermessi;
import net.mysoftworks.modulecompiler.model.values.RawValue;
import net.mysoftworks.modulecompiler.model.visitor.MetaFieldVisitor;
import org.apache.commons.lang3.StringUtils;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAttribute;
import java.util.HashSet;
import java.util.Set;

/**
 * MetaGruppo generated by hbm2java
 */
@Entity
@DiscriminatorValue("FILE")
public class MetaFileField extends MetaField implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	public MetaFileField(){super(BUSINESS_FIELD_TYPE.FILE);	}
	public MetaFileField(MetaFileField source) {
		super(source);
	}

	@ElementCollection(fetch= FetchType.EAGER)
	@CollectionTable(
			name="MC_M_FIELD_TYPE",
			joinColumns=@JoinColumn(name="FIELD", referencedColumnName="ID")/*,
			inverseJoinColumns=@JoinColumn(name="TYPE", referencedColumnName="ID")*/)
	@Column(name = "TYPE")
	private Set<Integer> fileTypes = new HashSet<>();
	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder("\nMetaFileField{");
		sb.append("fileTypes=").append(fileTypes);
		sb.append('}').append(super.toString());
		return sb.toString();
	}

	public Set<Integer> getFileTypes() {
		return fileTypes;
	}

	public void setFileTypes(Set<Integer> fileTypes) {
		this.fileTypes = fileTypes;
	}

	@Override
	public Object editValue(RawValue rawValue){
		return rawValue;
	}


	public void accept(MetaFieldVisitor visitor) {
		visitor.visit(this);
	}

	@Override
	public Object viewValue(RawValue rawValue) {
		if (rawValue==null) return null;
		return rawValue.getStringValue();
	}
}
